/*
  mainmenu.h
  Copyright (C) 2008-2010 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __MAINMENU_H__
#define __MAINMENU_H__

#include <qwidget.h>
#include <qmenubar.h>

class QFocusEvent;

class MainMenu : public QMenuBar
{
	Q_OBJECT
  public:
	MainMenu(QWidget *parent, const char *name = 0);

	void keyPressEvent(QKeyEvent * e);

  protected:
	QPopupMenu *settings_menu;
	QPopupMenu *help_menu;

	struct menu_items {
		const char *name;
		int id;
	};

	QPopupMenu *create_submenu(const char *name, struct menu_items *items, int count);

	enum {
		MENU_MAPPATH,
		MENU_GAMMA,
		MENU_GPS,
		MENU_CUSTOM_POI,
	};
};

#endif
