/*
  mainwindow.h
  Copyright (C) 2008-2009 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __MAINWINDOW_H__
#define __MAINWINDOW_H__

#include "mainwidget.h"
#include "pos.h"
#include "qgconf.h"
#include "qobjectlist.h"
#include <qstring.h>

class QWidget;
class QMenuBar;
class QPopupMenu;
class MainMenu;

#ifndef QWS
class QLabel;
#endif

class MainWindow : public QWidget
{
	Q_OBJECT
  public:
	MainWindow( QWidget *parent =0, const char *name = 0, WFlags fl = 0);
	~MainWindow();

	void keyPressEvent (QKeyEvent * e);
	void showEvent( QShowEvent *e );
	void closeEvent(QCloseEvent *e);

	void enableMenu();
	void disableMenu();

  private:
	QGConf *conf;

	MainWidget *main_widget;

	Mounter *mounter;
	MainMenu *menubar;

#ifndef QWS
	QLabel *label;
#endif

  protected slots:
	void recvQCop(const QCString &m, const QByteArray &d);
	void menu_activated(int id);

  signals:
	void setPosition(Pos &pos);
	void reload(bool);
	void cacheFlush();
	void movePosition(Pos &pos);
};
#endif // __MAINWINDOW_H__
