/*
  root.cpp
  Copyright (C) 2009 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <qstring.h>
#include "root.h"

static int g_root_authority = -1;

static void initRootAuthority()
{
	struct stat st;

	g_root_authority = 0;

	if(!stat("/proc/self/stat", &st)){
		if(st.st_uid == 0)
			g_root_authority = 1;
	}
}

int Root::isRootAuthority(void)
{
	if(g_root_authority < 0)
		initRootAuthority();

	return g_root_authority;
}

QString Root::RootSh(const QString &cmd)
{
	QString cmdline;

	if(g_root_authority < 0)
		initRootAuthority();

	if(g_root_authority)
		cmdline = "sh -c \"%0\"";
	else
		cmdline = "su -c \"%0\"";

	return cmdline.arg(cmd);
}

